/********************************** (C) COPYRIGHT *******************************
* File Name          : I2C.h
* Author             : WCH
* Version            : V1.0
* Date               : 2018/12/15
* Description 		 : 
*******************************************************************************/

#ifndef __I2C_SOFT2_H__
#define __I2C_SOFT2_H__
#include "CH57x_common.h"

#ifndef UINT8
typedef unsigned char           u8;
#endif
#define I2C_Pin_SCL		GPIO_Pin_4
#define I2C_Pin_SDA		GPIO_Pin_5

#define SCL_H         GPIOA_SetBits( I2C_Pin_SCL ) 
#define SCL_L         GPIOA_ResetBits( I2C_Pin_SCL ) 
#define SDA_H         GPIOA_SetBits( I2C_Pin_SDA ) 
#define SDA_L         GPIOA_ResetBits( I2C_Pin_SDA ) 
#define SCL_read      GPIOA_ReadPortPin( I2C_Pin_SCL ) 
#define SDA_read      GPIOA_ReadPortPin( I2C_Pin_SDA )  
#define SCL_out      	GPIOA_ModeCfg(I2C_Pin_SCL, GPIO_ModeOut_PP_5mA) 
#define SCL_in      	GPIOA_ModeCfg(I2C_Pin_SCL, GPIO_ModeIN_PU) 
#define SDA_out      	GPIOA_ModeCfg(I2C_Pin_SDA, GPIO_ModeOut_PP_5mA)  
#define SDA_in      	GPIOA_ModeCfg(I2C_Pin_SDA, GPIO_ModeIN_PU)  
			

void I2CInit(void);  
int I2C_7bit_Single_Write(u8 SlaveAddress,u8 REG_data);	
u8 I2C_7bit_Single_Read(u8 SlaveAddress);
int I2C_7bit_Mult_Read(u8 SlaveAddress,u8 * ptChar,u8 size);

int I2C_10bit_Single_Write(u8 SlaveAddress,u8 REG_Address,u8 REG_data);	
u8 I2C_10bit_Single_Read(u8 SlaveAddress,u8 REG_Address);
int I2C_10bit_Mult_Read(u8 SlaveAddress,u8 REG_Address,u8 * ptChar,u8 size);

void I2C_delay(void);
int I2C_Start(void);
void I2C_Stop(void);
void I2C_Ack(void); 
void I2C_NoAck(void);
int I2C_WaitAck(void); 	 //Ϊ:=1ACK,=0ACK
void I2C_SendByte(u8 SendByte);
u8 I2C_ReadByte(void);  //ݴӸλλ//


#endif
